<?php
import("php.db.DBClient");
import("php.db.MysqlConfig");

class Mysql extends DBClient {

	public function __construct($host = '', $port = '', $id = '', $pass = '', $db = '', $schema = '', $version = '') {
		$program		= strtoupper(__CLASS__);
		parent::__construct($program, $host, $port, $id, $pass, $db, $schema, $version);
	}

	public function error() {
		return mysql_error();
	}

	protected function _connect() { 
		return mysql_connect($this->getAttribute('host'), $this->getAttribute('id'), $this->getAttribute('pass'));
	}

	protected function _selectDb() { 
		mysql_select_db($this->getAttribute('db'), $this->con);
	}

	public function close()
	{
		if ($this->con) { 
			mysql_close($this->con);
		}
	}

	public function free($result) {
		if ($result) { 
			return mysql_free_result($result);
		}

		return false;
	}

	public function affectedRows() { 
		return mysql_affected_rows($this->con);
	}

	public function escape($str) { 
		return mysql_real_escape_string($str);
	}

	public function query($sql) {
		$this->result = mysql_query($sql, $this->con);
		return $this->result;
	}

	public function getFieldCount($result) {
		return mysql_num_fields($result);
	}

	public function getFieldName($result, $i) {
		return mysql_field_name($result, $i);
	}

	public function getFieldType($result, $i) {
		return mysql_field_type($result, $i);
	}

	// Ÿ  
	public function fetch($result) {
		return mysql_fetch_assoc($result);
	}
	
	function getPageData($query, $page, $count = 10,$baseClass = 'DBData')
	{
		//  ϱ 
		$start = ($page-1)*$count;

		$query .= " limit $start, $count";

		return $this->getData($query, false, $baseClass);
	}


	/* Ÿ Ÿ ̽  */

	/**
	 *  ̺  
	 */
	public function getTableData($data) {

		$key = 'TABLES_IN_'.$this->getAttribute('db');
		$data->convertField(array($key => 'NAME')); 
			
		$data->addField('dbowner');
		$data->addField('create_date');

		while($data->next()) { 
			$data->dbowner = $this->getAttribute('db');
		}

		$data->init();

		return $data;
	}


	/**
	 *  ʵ  
	 */
	public function getColumnData($data, $object) {

		$temp_data = new DBData($this);
		$temp_data->setFields(
				array(
					'TABLE_NAME',
					'ORDINAL_POSITION',
					'COLUMN_NAME',
					'COLUMN_COMMENT', 
					'DATA_TYPE', 
					'COLUMN_TYPE', 
					'DATA_LENGTH',
					'DATA_PREC',
					'DATA_SCALE',
					'ISNULL',
					'OPTIONS', 
					'ISAUTO',
					'COLUMN_DEFAULT',
					'PK',
					'UQ',
					'C'
				)
		);

		while($data->next()) { 
			$temp_data->add(
				array(
					'TABLE_NAME'		=> $object,
					'ORDINAL_POSITION'	=> $data->getIndex() + 1,
					'COLUMN_NAME'		=> $data->field,
					'COLUMN_COMMENT'	=> '', 
					'DATA_TYPE'			=> $data->type, 
					'COLUMN_TYPE'			=> $data->type, 
					'DATA_LENGTH'		=> '',
					'DATA_PREC'			=> '',
					'DATA_SCALE'		=> '',
					'ISNULL'			=> ($data->null == 'YES') ? 'NULL' : '',
					'OPTIONS'			=> $data->extra, 
					'ISAUTO'			=> (trim(strtolower($data->extra)) == 'auto_increment') ? 'Y' : 'N',
					'COLUMN_DEFAULT'	=> $data->default,
					'PK'				=> ($data->key == 'PRI') ? 'PK' : '',
					'UQ'				=> '',
					'C'					=> ''
				)	
			);

		}

		$data = $temp_data;

		return $data;
	}

	/**
	 * ε 
	 */
	public function getIndexData($data) { 

		$temp_data = new DBData($this);
		$temp_data->setFields(
				array(
					'TABLE_NAME',
					'INDEX_NAME',
					'COLUMN_POSITION',	
					'COLUMN_NAME',
					'DESCEND',
					'UQ',
					'PK',
					'INDEX_TYPE',
					'ISNULL',
					'COMMENT'
				)
		);

		while($data->next()) { 
			$temp_data->add(
				array(
					'TABLE_NAME'		=> $data->table,
					'INDEX_NAME'		=> $data->key_name,
					'COLUMN_POSITION'	=> $data->seq_in_index,	
					'COLUMN_NAME'		=> $data->column_name,
					'DESCEND'			=> ($data->collation == 'A') ? 'ASC' : 'DESC',
					'UQ'				=> ($data->non_unique == 1) ? '' : 'UQ',
					'PK'				=> ($data->key_name == 'PRIMARY') ? 'PK' : '',
					'INDEX_TYPE'		=> $data->index_type,
					'ISNULL'			=> ($data->null == 'YES') ? 'Y' : 'N',
					'COMMENT'			=> $data->comment
				)	
			);

		}

		$data = $temp_data;


		return $data;
	}


	public function getMetaData($meta_type, $object = '') { 
		$data = parent::getMetaData($meta_type, $object);

		// param   
		if (strtoupper($meta_type) == 'PARAM') { 
			return new DBData();
		}

		if (strtoupper($meta_type) == 'INDEX') {	// ε Ÿ ȯ
			return $this->getIndexData($data);
		} 

		//  4϶ 
		if ($this->getAttribute('version') == 4) {	
			if (strtoupper($meta_type) == 'TABLE') {		// ̺ Ÿ ȯ
				$data = $this->getTableData($data);
			} else if (strtoupper($meta_type) == 'COLUMN') {	// ε Ÿ ȯ
				$data = $this->getColumnData($data, $object);
			}
		} 

		return $data;
	}
}

?>